package com.app.service;

import java.net.URL;
import java.util.List;

import javax.ejb.Stateless;
import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Holder;
import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.MessageContext;

import com.app.util.LogRequest;
import com.soap.bean.CustomerDetailType;
import com.soap.bean.CustomerSOAP;
import com.soap.bean.CustomerSOAPService;
import com.soap.bean.Header;

@Stateless
public class CustomerService {

  private static final QName SERVICE_NAME = new QName("http://www.soap.poc.edu/CustomerSOAP/", "CustomerSOAPService");
  
  public CustomerDetailType getCustomerDetails(String custId, String type, String mockUrl) {
    return getCustomerDetailMet(mockUrl);
  }
  
  public CustomerDetailType getCustomerDetailMet(String mockUrl){
    URL wsdlURL = CustomerSOAPService.WSDL_LOCATION;
    
    CustomerSOAPService ss = new CustomerSOAPService(wsdlURL, SERVICE_NAME);
    CustomerSOAP port = ss.getCustomerSOAPSOAPBind();  
    
    BindingProvider bp = (BindingProvider) port;
    bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY,mockUrl);
    
    List<Handler> handlers = bp.getBinding().getHandlerChain();
    handlers.add(new LogRequest());
    bp.getBinding().setHandlerChain(handlers);
    
    String _getCustomerDetail_customerId = "89950";
    String _getCustomerDetail_customerType = "RET";
/*    Header header = new Header();
    header.setCaller("TEST");
    header.setTransactionId("234242");
*/    
    Holder<String> _getCustomerDetail_fname = new Holder<String>();
    Holder<String> _getCustomerDetail_lname = new Holder<String>();
    Holder<String> _getCustomerDetail_mobile = new Holder<String>();
    Holder<String> _getCustomerDetail_emailId = new Holder<String>();
    Holder<String> _getCustomerDetail_zip = new Holder<String>();
    CustomerDetailType customer = null;
    try {
      //port.getCustomerDetail(_getCustomerDetail_customerId, _getCustomerDetail_customerType, header, _getCustomerDetail_fname, _getCustomerDetail_lname, _getCustomerDetail_mobile, _getCustomerDetail_emailId, _getCustomerDetail_zip);
      port.getCustomerDetail(_getCustomerDetail_customerId, _getCustomerDetail_customerType, _getCustomerDetail_fname, _getCustomerDetail_lname, _getCustomerDetail_mobile, _getCustomerDetail_emailId, _getCustomerDetail_zip);
      customer = new CustomerDetailType();
      customer.setFname(_getCustomerDetail_fname.value);
      customer.setLname(_getCustomerDetail_lname.value);
      customer.setEmailId(_getCustomerDetail_emailId.value);
      customer.setMobile(_getCustomerDetail_mobile.value);
      customer.setZip(_getCustomerDetail_zip.value);

    } catch (Exception ex) {
      ex.printStackTrace();
    }
    return customer;
  }
  
}
